/*	This script created by Christopher Bradford, Alive! Online.

	This script deletes the current tag, including end tag (if applicable).
	It will also delete unmatched tags, such as orphan start or end tags
	and empty tags such as <br> and <img>.

	You may distribute this freely, but please keep the headers intact.

	Installation:
	Create a custom button for the .js file

	Copyright 2000
 	Christopher Bradford
	bradford@aliveonline.com
*/

// MessageBox constants
var hsOK = 0;
var hsExclamation = 48;


// these are used for the ExecCommand method
var selectMatchingTag = 76;
var deleteSelection = 45;

var app = Application;
var active = app.ActiveDocument;

function Main() {

var intOrigStart = active.SelStart;
active.BeginUpdate();
app.ExecCommand(selectMatchingTag,0);
if (active.SelStart != intOrigStart && active.SelLength > 2) {	// if there is a matching tag
	var intStart = active.SelStart;
	var intLength = active.SelLength;
	
	app.ExecCommand(selectMatchingTag,0);
	
	var intOffset = active.SelLength;
	var intNewPos = active.SelStart;
	
	var strTag = active.SelText;
	var isStartTag = (strTag.slice(1,2) == "/" ? false : true);
	
	app.ExecCommand(deleteSelection,0);

	if (isStartTag) {
		active.SelStart = intStart - intOffset;
	}
	else {
		active.SelStart = intStart;
	}

	active.SelLength = intLength;

	app.ExecCommand(deleteSelection,0);

	if (isStartTag) {
		active.SelStart = intNewPos
	}	
	else {
		active.SelStart = intNewPos - intLength;
	}
	active.EndUpdate();
}
else {	// it's a tag without a match
	active.GotoPreviousStartTag(false);
	active.GotoNextStartTag(true);
	if (intOrigStart >= active.SelStart && intOrigStart <= active.SelStart + active.SelLength) {	// it's a starting tag without a match
		app.ExecCommand(deleteSelection, 0);
	}
	else {	// it's an ending tag
		active.SelStart = intOrigStart - 1;
		var currChar = active.GetCurrentChar();
		while (currChar != "<") {
			active.SelStart = active.SelStart - 1;
			currChar = active.GetCurrentChar();
		}
		var intStartHere = active.SelStart + 1;
		while (currChar != ">") {
			active.SelStart = active.SelStart + 1;
			currChar = active.GetCurrentChar();
		}
		var intEndHere = active.SelStart + 1;
		active.SelStart = intStartHere - 1;
		active.SelLength = intEndHere - intStartHere + 1;
		app.ExecCommand(deleteSelection, 0);
	}
	active.EndUpdate();
}
}